#!/usr/bin/ruby
#
# Copyright (c) 2000 Yasuhiro ABE <yasu@dengaku.org>
#

require "rnids"

n = NIDS.new

printf "sk_buff_size is %d\n", NIDSupport::sk_buff_size
NIDSupport::sk_buff_size(1024)
printf "sk_buff_size is %d\n", NIDSupport::sk_buff_size

def n.callback(tcph)
  if tcph.kind_of?(NIDS_TCP) && tcph.tcp_state == NIDS::NIDS_DATA
    if tcph.tcp_direction?
      printf "%s:%d -> %s:%d\n", tcph.tcp_saddr,tcph.tcp_sport,tcph.tcp_daddr,tcph.tcp_dport
      printf "=> %s\n", tcph.tcp_data[0,24].dump
    else
    printf "%s:%d <- %s:%d\n", tcph.tcp_saddr,tcph.tcp_sport,tcph.tcp_daddr,tcph.tcp_dport
    printf "=> %s\n", tcph.tcp_data[0,24].dump
    end
  end
end

n.run
